# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    api_url = "https://sourceforge.net/projects/freepascal/best_release.json"
    update_dict = {
        # "bin_contains": {
        #     "x64": "-x64-svn-",
        #     "arm64": "-ARM64-svn-",
        #     "x86": "-win32-svn-",
        # },
        "latest_bin_to_substitute": {
            "x64": ".tar",
        },
    }

    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = wgets(api_url, proxies=proxies, as_json=True)
    for to_download in json_load["platform_releases"]:
        if "-x86_64-linux" in json_load['platform_releases']['linux']['filename']:
            latest_bin = json_load["platform_releases"]['linux']["filename"].split("/")[-1]
            download_url = json_load["platform_releases"]['linux']["url"].replace("http://", "https://")
            version = json_load["platform_releases"]['linux']["filename"].split("-")[1].split(".intel")[0]
            break

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)


    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)
